#include <stdio.h>
#include <stdlib.h>
#include "zasobnik.h"

#define BUFFER 512

int strnum(char *string)
{
    int j = 0;
	while(string[j]!='\0')
		j++;
	return j;
}

void infix2postfix(char *infix)
{
	int i, 
		num = strnum(infix) ;
	
    for (i = 0; i < num; i++)
    {
        if (infix[i] == ')')
          printf(" %c", pop()); 
		
        if ((infix[i] == '+') || (infix[i] == '*')|| (infix[i] == '/') || (infix[i] == '-')) 
          push(infix[i]);
			
        if ((infix[i] >= 'a') && (infix[i] <= 'z')) 
          printf(" %c", infix[i]); 
    }

	putchar('\n');
}

void infix2prefix(char *infix)
{
	int i, j = 0, 
		num = strnum(infix) ;
	
	char output[BUFFER];
		
    for (i = num - 1; i >= 0; i--)
    {
        if (infix[i] == '(')
		{
			output[j] = pop(); j++;
			output[j] = ' '; j++;
		}
		
        if ((infix[i] == '+') || (infix[i] == '*')|| (infix[i] == '/') || (infix[i] == '-')) 
			push(infix[i]);
			
        if ((infix[i] >= 'a') && (infix[i] <= 'z')) 
		{
			output[j] = infix[i]; j++;
			output[j] = ' '; j++;
		}
 	}
	
	output[j] = '\0'; 

	num = strnum(output);
		
    for (i = num - 1; i >= 0; i--)
		putchar(output[i]);

	putchar('\n');
}


int main(int argc, char *argv[])
  { 
	FILE *fp;
	char input[BUFFER];

	fp = fopen("data.txt", "r");

	while(fgets(input, BUFFER-1, fp)!=NULL)
	{
		if(strnum(input)>3)
		{
			printf("Infix   :  %s", input);

			stack_create();
				printf("Postfix : ");
				infix2postfix(input);
				printf("Prefix  : ");
				infix2prefix(input);
			stack_free();
		
			putchar('\n');
		}
	}
	return 0;
  } 

